{
	"Id": 1,
	"TemplateName": "AliExpress product card scraper",
	"TemplateFileName": "aliexpress-settings-06may2020-2.json",
	"TemplateWebsiteURL": "https://aliexpress.com",
	"TemplateDescription": "Extraction of common product information, pictures and all possible combinations of product params with their prices.",
	"TemplateUpdateDate": "2020-05-15T14:13:46.4960634+03:00",
	"IsDeleted": 0,
	"TemplateCategory": 1,
	"ProjectTemplateUICardStyling": {
		"TemplateShortName": "AE",
		"CardBackgroundColorHex": "#ff9900",
		"FontColorHex": "#e72e04"
	},
	"TemplateParams": null,
	"ExcavatorProjectPackedData": {
		"ProjectName": "AliExpressProductsParser",
		"WebsiteRootUrl": "https://aliexpress.com",
		"ProjectDescription": "Express project",
		"CrawlerPeroperties": {
			"PrimaryDataCrawlingWay": 1,
			"RespectOnlySpecifiedUrls": [],
			"UrlSubstringsRestrictions": [
				".css",
				".js",
				"assets",
				".png",
				".jpg",
				".jpeg",
				".bmp",
				".exe",
				".msi",
				"login",
				"report",
				"ipp.",
				"my.",
				"message.",
				"plugins",
				"m.aliexpress",
				"service."
			],
			"RespectRobotsTxtFile": true,
			"RobotsTxtUserAgentRespectationChain": [
				"Googlebot",
				"Yandex",
				"*",
				"YandexBot"
			],
			"RobotsTxtReindexTimeDays": 3,
			"CrawlingThreadsCount": 3,
			"CrawlingThreadDelayMilliseconds": 5000,
			"CrawlerUserAgent": "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/74.0.3729.169 Safari/537.36",
			"HttpWebRequestMethod": "GET",
			"CrawlingRequestAdditionalParamsList": null,
			"SitemapUrl": "",
			"SitemapReindexTimeDays": 3,
			"PagesToCrawlLimit": -1,
			"PageDownloadTimeoutMilliseconds": 40000,
			"PageDownloadAttempts": 3,
			"CrawlWebsiteLinks": true,
			"StoreCrawledData": true,
			"StoreCrawledPagesHTMLSource": false,
			"ReindexCrawledPages": false,
			"ReindexCrawledPagesAfterSpecifiedMinutesInterval": 10080,
			"HTTPWebRequestProxiesList": null,
			"ProxiesRotation": 0,
			"LinksBufferHDDAutoSavingMilliseconds": 60000,
			"ConcurrentCollectionsParallelismQuantity": 2,
			"CEFCrawlingBehaviors": [
				{
					"PageUrlSubstringPattern": "*",
					"WaitAfterPageLoaded_InSeconds_Step1": 2,
					"JSScriptToExecute_Step2": "\r\n(function(d) {\r\n  \r\n if (window.location.href.indexOf('item/') === -1)\r\n  return;\r\n  \r\n /* Scroll page to bottom */\r\n setTimeout(function() { window.scrollTo( 0, 1000 ); }, 1000);\r\n setTimeout(function() { window.scrollTo( 0, 2500 ); }, 3000);\r\n setTimeout(function() { window.scrollTo( 0, 5000 ); }, 6000);\r\n setTimeout(function() { window.scrollTo( 0, 6500 ); }, 8000);\r\n \r\n /* Remove empty images */\r\n setTimeout(function() {\r\n  d.querySelectorAll(`img[src='https://ae01.alicdn.com/kf/HTB13SZpXpP7gK0jSZFj7635aXXaw.png']`).forEach(function(elementData) { elementData.remove(); });\r\n }, 8500);\r\n \r\n /* -------------- IMAGES BLOCK --------------- */\r\n /* Prepare images from main framg */\r\n /* Prepare SRCbar */\r\n var imagesBarElement = d.createElement('div');\r\n imagesBarElement.setAttribute('id', 'item-images-aex');\r\n d.body.appendChild(imagesBarElement);\r\n \r\n /* Itterate images */\r\n window.runParams.data.imageModule.imagePathList.forEach(function(nextPathImage) {\r\n  var nextElementWithSRC = d.createElement('p');\r\n  nextElementWithSRC.setAttribute('data-src', nextPathImage);\r\n  imagesBarElement.appendChild(nextElementWithSRC);\r\n });\r\n\r\n /* -------------- PROPERTIES BLOCK --------------- */\r\n /* Prepare PropsBar */\r\n var propertiesBarElement = d.createElement('div');\r\n propertiesBarElement.setAttribute('id', 'item-props-aex');\r\n d.body.appendChild(propertiesBarElement);\r\n \r\n /* Itterate props */\r\n if (typeof window.runParams.data.specsModule.props !== 'undefined') window.runParams.data.specsModule.props.forEach(function(nextPropData) {\r\n  var nextPropertyElement = d.createElement('p');\r\n  nextPropertyElement.innerHTML = nextPropData.attrName + ': ' + nextPropData.attrValue;\r\n  propertiesBarElement.appendChild(nextPropertyElement);\r\n });\r\n \r\n /* ----------- PRODUCT DESCRIPTION URL ------------ */\r\n var productDescriptionUrl = window.runParams.data.descriptionModule.descriptionUrl;\r\n var descriptionUrlElement = d.createElement('div');\r\n descriptionUrlElement.setAttribute('id', 'item-descriptionurl-aex');\r\n descriptionUrlElement.setAttribute('data-url', productDescriptionUrl);\r\n d.body.appendChild(descriptionUrlElement);\r\n\r\n}(document));",
					"WaitAfterpageLoaded_InSeconds_Step3": 10,
					"LeavePageRule": 0,
					"JSScriptToExecuteAfterPageHTMLCodeGrabbed": "",
					"LeavePageRuleValue": ""
				}
			],
			"CEFWebsiteAuthenticationBehavior": null
		},
		"GrabberProperties": {
			"GrabbingThreadsCount": 3,
			"GrabbingThreadDelayMilliseconds": 5000,
			"StoreGrabbedData": true,
			"StoreOnlyNonEmptyData": true,
			"ExportDataOnline": false,
			"ExportDataOnlineInvokationLink": ""
		},
		"GrabbingPatterns": [
			{
			  "PatternName": "AliExpressProductPage",
			  "AllowedPageUrlsSubstrings": [
				"item"
			  ],
			  "OuterBlockSelector": null,
			  "GrabbingItemsPatterns": [
				{
				  "ElementName": "ProductName",
				  "DataSelector": {
					"Selector": "[itemprop=\"name\"]",
					"SelectorType": 0
				  },
				  "ParseBinaryAttributes": false,
				  "ParsingBinaryAttributes": []
				},
				{
				  "ElementName": "ProductEndPrice",
				  "DataSelector": {
					"Selector": "[itemprop=\"price\"]",
					"SelectorType": 0
				  },
				  "ParseBinaryAttributes": false,
				  "ParsingBinaryAttributes": []
				},
				{
				  "ElementName": "ProductShippingPrice",
				  "DataSelector": {
					"Selector": ".product-shipping-price",
					"SelectorType": 0
				  },
				  "ParseBinaryAttributes": false,
				  "ParsingBinaryAttributes": []
				},
				{
				  "ElementName": "ProductQuantity",
				  "DataSelector": {
					"Selector": ".product-quantity-info span",
					"SelectorType": 0
				  },
				  "ParseBinaryAttributes": false,
				  "ParsingBinaryAttributes": []
				},
				{
				  "ElementName": "ProductRateSummary",
				  "DataSelector": {
					"Selector": ".overview-rating-average",
					"SelectorType": 0
				  },
				  "ParseBinaryAttributes": false,
				  "ParsingBinaryAttributes": []
				},
				{
				  "ElementName": "ProductSoldCount",
				  "DataSelector": {
					"Selector": ".product-reviewer-sold",
					"SelectorType": 0
				  },
				  "ParseBinaryAttributes": false,
				  "ParsingBinaryAttributes": []
				},
				{
				  "ElementName": "ProductDescription",
				  "DataSelector": {
					"Selector": "#product-description",
					"SelectorType": 0
				  },
				  "ParseBinaryAttributes": false,
				  "ParsingBinaryAttributes": []
				},
				{
				  "ElementName": "ProductDescriptionImages",
				  "DataSelector": {
					"Selector": "#product-description img",
					"SelectorType": 0
				  },
				  "ParseBinaryAttributes": true,
				  "ParsingBinaryAttributes": [
					{
					  "AttributeName": "src",
					  "IsAttributeAreLinkToSomeResouce": true,
					  "IsWeMustDownloadContentUnderAttributeLink": true
					}
				  ]
				},
				{
				  "ElementName": "ProductMainImages",
				  "DataSelector": {
					"Selector": "#item-images-aex p",
					"SelectorType": 0
				  },
				  "ParseBinaryAttributes": true,
				  "ParsingBinaryAttributes": [
					{
					  "AttributeName": "data-src",
					  "IsAttributeAreLinkToSomeResouce": true,
					  "IsWeMustDownloadContentUnderAttributeLink": true
					}
				  ]
				},
				{
				  "ElementName": "ProductProperties",
				  "DataSelector": {
					"Selector": "#item-props-aex p",
					"SelectorType": 0
				  },
				  "ParseBinaryAttributes": false,
				  "ParsingBinaryAttributes": []
				},
				{
				  "ElementName": "ProductVideo",
				  "DataSelector": {
					"Selector": ".video-container-detail video",
					"SelectorType": 0
				  },
				  "ParseBinaryAttributes": true,
				  "ParsingBinaryAttributes": [
					{
					  "AttributeName": "src",
					  "IsAttributeAreLinkToSomeResouce": true,
					  "IsWeMustDownloadContentUnderAttributeLink": false
					}
				  ]
				},
				{
				  "ElementName": "ItemDescriptionURL",
				  "DataSelector": {
					"Selector": "#item-descriptionurl-aex",
					"SelectorType": 0
				  },
				  "ParseBinaryAttributes": true,
				  "ParsingBinaryAttributes": [
					{
					  "AttributeName": "data-url",
					  "IsAttributeAreLinkToSomeResouce": true,
					  "IsWeMustDownloadContentUnderAttributeLink": false
					}
				  ]
				}
			  ]
			}
		]
	}
}